package cn.ibizlab.assetmanagement.core.plan.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.assetmanagement.core.plan.domain.EAMPlanSchedule;
import cn.ibizlab.assetmanagement.core.plan.filter.EAMPlanScheduleSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EAMPlanSchedule] 服务对象接口
 */
public interface IEAMPlanScheduleService extends IService<EAMPlanSchedule>{

    boolean create(EAMPlanSchedule et) ;
    void createBatch(List<EAMPlanSchedule> list) ;
    boolean update(EAMPlanSchedule et) ;
    void updateBatch(List<EAMPlanSchedule> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EAMPlanSchedule get(String key) ;
    EAMPlanSchedule getDraft(EAMPlanSchedule et) ;
    boolean checkKey(EAMPlanSchedule et) ;
    boolean save(EAMPlanSchedule et) ;
    void saveBatch(List<EAMPlanSchedule> list) ;
    Page<EAMPlanSchedule> searchDefault(EAMPlanScheduleSearchContext context) ;
    List<EAMPlanSchedule> selectByEamplanid(String eamplanid) ;
    void removeByEamplanid(String eamplanid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<EAMPlanSchedule> getEamplanscheduleByIds(List<String> ids) ;
    List<EAMPlanSchedule> getEamplanscheduleByEntities(List<EAMPlanSchedule> entities) ;
}


